Index: /branches/2018/dev_r8864_nemo_v3_6_ZTILDE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90
===================================================================
--- /branches/2018/dev_r8864_nemo_v3_6_ZTILDE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 9352)
+++ /branches/2018/dev_r8864_nemo_v3_6_ZTILDE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 9353)
@@ -446,48 +596,85 @@
             ENDIF
          ENDIF
-         ! - ML - end test
-         ! - ML - Imposing these limits will cause a baroclinicity error which is corrected for below
-         tilde_e3t_a(:,:,:) = MIN( tilde_e3t_a(:,:,:),   rn_zdef_max * e3t_0(:,:,:) )
-         tilde_e3t_a(:,:,:) = MAX( tilde_e3t_a(:,:,:), - rn_zdef_max * e3t_0(:,:,:) )
-
-         !
-         ! "tilda" change in the after scale factor
-         ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+         IF ( ln_vvl_ztilde ) THEN
+            zalpha  = rdt * 2.0_wp * rpi / ( MAX( rn_lf_cutoff, rsmall ) * 86400.0_wp )
+            DO jk = 1, jpkm1
+               ztu(:,:,jk) = un(:,:,jk) * fse3u_n(:,:,jk) * e2u(:,:) + un_td(:,:,jk)
+               ztv(:,:,jk) = vn(:,:,jk) * fse3v_n(:,:,jk) * e1v(:,:) + vn_td(:,:,jk)
+               ze3t(:,:,jk) = -fse3t_n(:,:,jk) * zhdiv(:,:)
+!
+!               DO jj = 2, jpjm1
+!                  DO ji = fs_2, fs_jpim1   ! vector opt.
+!                     
+!                     ze3t(ji,jj,jk) =   -fse3t_n(ji,jj,jk) * zhdiv(ji,jj)   &
+!                        & + (  un_td(ji,jj,jk) - un_td(ji-1,jj  ,jk)        &
+!                        &    + vn_td(ji,jj,jk) - vn_td(ji  ,jj-1,jk)  )     &
+!                        & / ( e1t(ji,jj) * e2t(ji,jj) )
+!                  END DO
+!               END DO 
+            END DO
+            !
+            un_lf(:,:,:)    = un_lf(:,:,:)    * (1._wp - zalpha) + zalpha * ztu(:,:,:)
+            vn_lf(:,:,:)    = vn_lf(:,:,:)    * (1._wp - zalpha) + zalpha * ztv(:,:,:)
+            hdivn_lf(:,:,:) = hdivn_lf(:,:,:) * (1._wp - zalpha) + zalpha * ze3t(:,:,:)
+         ENDIF
+
+      ENDIF
+
+      IF((ln_vvl_ztilde .OR. ln_vvl_layer).AND.(.NOT.ll_do_bclinic) ) THEN
+         zhdiv(:,:) = 0.
          DO jk = 1, jpkm1
-            dtilde_e3t_a(:,:,jk) = tilde_e3t_a(:,:,jk) - tilde_e3t_b(:,:,jk)
-         END DO
-         ! III - Barotropic repartition of the sea surface height over the baroclinic profile
-         ! ==================================================================================
-         ! add ( ssh increment + "baroclinicity error" ) proportionly to e3t(n)
-         ! - ML - baroclinicity error should be better treated in the future
-         !        i.e. locally and not spread over the water column.
-         !        (keep in mind that the idea is to reduce Eulerian velocity as much as possible)
-         zht(:,:) = 0.
+            zhdiv(:,:) = zhdiv(:,:) + fse3t_n(:,:,jk) * (hdivn(:,:,jk) - hdivb(:,:,jk))
+         END DO
+         zhdiv(:,:) = zhdiv(:,:) / ( ht_0(:,:) + sshn(:,:) + 1. - tmask(:,:,1) )
+
+         IF( neuler == 0 .AND. kt == nit000 ) THEN
+            z2dt =  rdt
+         ELSE
+            z2dt = 2.0_wp * rdt
+         ENDIF
+
          DO jk = 1, jpkm1
-            zht(:,:)  = zht(:,:) + tilde_e3t_a(:,:,jk) * tmask(:,:,jk)
-         END DO
-         z_scale(:,:) =  - zht(:,:) / ( ht_0(:,:) + sshn(:,:) + 1. - ssmask(:,:) )
+            tilde_e3t_a(:,:,jk) = tilde_e3t_a(:,:,jk) - z2dt * fse3t_n(:,:,jk) * & 
+                                  & (hdivn(:,:,jk) - hdivb(:,:,jk) - zhdiv(:,:))
+         END DO
+      ENDIF
+
+      IF( ln_vvl_ztilde .OR. ln_vvl_layer )  THEN   ! z_tilde or layer coordinate !
+      !                                             ! ---baroclinic part--------- !
          DO jk = 1, jpkm1
-            dtilde_e3t_a(:,:,jk) = dtilde_e3t_a(:,:,jk) + fse3t_n(:,:,jk) * z_scale(:,:) * tmask(:,:,jk)
-         END DO
-
+            fse3t_a(:,:,jk) = fse3t_a(:,:,jk) + (tilde_e3t_a(:,:,jk) - tilde_e3t_b(:,:,jk))                     
+         END DO
       ENDIF
 
-      IF( ln_vvl_ztilde .OR. ln_vvl_layer )  THEN   ! z_tilde or layer coordinate !
-      !                                           ! ---baroclinic part--------- !
+      IF( ln_vvl_dbg .AND. .NOT. ll_do_bclinic ) THEN   ! - ML - test: control prints for debuging
+         !
+         zht(:,:) = 0.0_wp
          DO jk = 1, jpkm1
-            fse3t_a(:,:,jk) = fse3t_a(:,:,jk) + dtilde_e3t_a(:,:,jk) * tmask(:,:,jk)
-         END DO
-      ENDIF
-
-      IF( ln_vvl_dbg .AND. .NOT. ll_do_bclinic ) THEN   ! - ML - test: control prints for debuging
-         !
+            zht(:,:) = zht(:,:) + tilde_e3t_a(:,:,jk) * tmask(:,:,jk)
+         END DO
          IF( lwp ) WRITE(numout, *) 'kt =', kt
          IF ( ln_vvl_ztilde .OR. ln_vvl_layer ) THEN
-            z_tmax = MAXVAL( tmask(:,:,1) * tmask_i(:,:) * ABS( zht(:,:) ) )
+            z_tmax = MAXVAL( tmask(:,:,1) * tmask_i(:,:) * ABS( zht(:,:) ), mask = tmask(:,:,1) == 1.e0 )
             IF( lk_mpp ) CALL mpp_max( z_tmax )                             ! max over the global domain
             IF( lwp    ) WRITE(numout, *) kt,' MAXVAL(abs(SUM(tilde_e3t_a))) =', z_tmax
          END IF
          !
+         z_tmin = MINVAL( fse3t_n(:,:,:), mask = tmask(:,:,:) == 1.e0  )
+         IF( lk_mpp )   CALL mpp_min( z_tmin )                 ! min over the global domain
+         IF( lwp    ) WRITE(numout, *) kt,' MINVAL(fse3t_n) =', z_tmin         
+         !
+         z_tmin = MINVAL( fse3u_n(:,:,:), mask = umask(:,:,:) == 1.e0 )
+         IF( lk_mpp )   CALL mpp_min( z_tmin )                 ! min over the global domain
+         IF( lwp    ) WRITE(numout, *) kt,' MINVAL(fse3u_n) =', z_tmin
+         !
+         z_tmin = MINVAL( fse3v_n(:,:,:), mask = vmask(:,:,:) == 1.e0 )
+         IF( lk_mpp )   CALL mpp_min( z_tmin )                 ! min over the global domain
+         IF( lwp    ) WRITE(numout, *) kt,' MINVAL(fse3v_n) =', z_tmin
+         !
+         z_tmin = MINVAL( fse3f_n(:,:,:), mask = fmask(:,:,:) == 1.e0 )
+         IF( lk_mpp )   CALL mpp_min( z_tmin )                 ! min over the global domain
+         IF( lwp    ) WRITE(numout, *) kt,' MINVAL(fse3f_n) =', z_tmin
+         !
          zht(:,:) = 0.0_wp
          DO jk = 1, jpkm1
@@ -496,33 +683,58 @@
          z_tmax = MAXVAL( tmask(:,:,1) * tmask_i(:,:) * ABS( ht_0(:,:) + sshn(:,:) - zht(:,:) ) )
          IF( lk_mpp ) CALL mpp_max( z_tmax )                                ! max over the global domain
-         IF( lwp    ) WRITE(numout, *) kt,' MAXVAL(abs(ht_0+sshn-SUM(fse3t_n))) =', z_tmax
+         IF( lwp    ) WRITE(numout, *) kt,' MAXVAL(abs(ht_0+sshn  -SUM(fse3t_n))) =', z_tmax
          !
          zht(:,:) = 0.0_wp
          DO jk = 1, jpkm1
-            zht(:,:) = zht(:,:) + fse3t_a(:,:,jk) * tmask(:,:,jk)
-         END DO
-         z_tmax = MAXVAL( tmask(:,:,1) * tmask_i(:,:) * ABS( ht_0(:,:) + ssha(:,:) - zht(:,:) ) )
+            zht(:,:) = zht(:,:) + fse3u_n(:,:,jk) * umask(:,:,jk)
+         END DO
+         zwu(:,:) = 0._wp
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               zwu(ji,jj) = 0.5_wp * umask(ji,jj,1) * r1_e12u(ji,jj)                             &
+                        &          * ( e12t(ji,jj) * sshn(ji,jj) + e12t(ji+1,jj) * sshn(ji+1,jj) )
+            END DO
+         END DO
+         CALL lbc_lnk( zwu(:,:), 'U', 1._wp )
+         z_tmax = MAXVAL( umask(:,:,1) * umask_i(:,:) * ABS( hu_0(:,:) + zwu(:,:) - zht(:,:) ) )
          IF( lk_mpp ) CALL mpp_max( z_tmax )                                ! max over the global domain
-         IF( lwp    ) WRITE(numout, *) kt,' MAXVAL(abs(ht_0+ssha-SUM(fse3t_a))) =', z_tmax
+         IF( lwp    ) WRITE(numout, *) kt,' MAXVAL(abs(hu_0+sshu_n-SUM(fse3u_n))) =', z_tmax
          !
          zht(:,:) = 0.0_wp
          DO jk = 1, jpkm1
-            zht(:,:) = zht(:,:) + fse3t_b(:,:,jk) * tmask(:,:,jk)
-         END DO
-         z_tmax = MAXVAL( tmask(:,:,1) * tmask_i(:,:) * ABS( ht_0(:,:) + sshb(:,:) - zht(:,:) ) )
+            zht(:,:) = zht(:,:) + fse3v_n(:,:,jk) * vmask(:,:,jk)
+         END DO
+         zwv(:,:) = 0._wp
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               zwv(ji,jj) = 0.5_wp * vmask(ji,jj,1) * r1_e12v(ji,jj)                             &
+                        &          * ( e12t(ji,jj) * sshn(ji,jj) + e12t(ji,jj+1) * sshn(ji,jj+1) )
+            END DO
+         END DO
+         CALL lbc_lnk( zwv(:,:), 'V', 1._wp )
+         z_tmax = MAXVAL( vmask(:,:,1) * vmask_i(:,:) * ABS( hv_0(:,:) + zwv(:,:) - zht(:,:) ) )
          IF( lk_mpp ) CALL mpp_max( z_tmax )                                ! max over the global domain
-         IF( lwp    ) WRITE(numout, *) kt,' MAXVAL(abs(ht_0+sshb-SUM(fse3t_b))) =', z_tmax
-         !
-         z_tmax = MAXVAL( tmask(:,:,1) *  ABS( sshb(:,:) ) )
+         IF( lwp    ) WRITE(numout, *) kt,' MAXVAL(abs(hv_0+sshv_n-SUM(fse3v_n))) =', z_tmax
+         !
+         zht(:,:) = 0.0_wp
+         DO jk = 1, jpkm1
+            DO jj = 1, jpjm1
+               zht(:,jj) = zht(:,jj) + fse3f_n(:,jj,jk) * umask(:,jj,jk)*umask(:,jj+1,jk)
+            END DO
+         END DO
+         zwu(:,:) = 0._wp
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               zwu(ji,jj) = 0.25_wp * umask(ji,jj,1) * umask(ji,jj+1,1) * r1_e12f(ji,jj)  &
+                        &          * (  e12t(ji  ,jj) * sshn(ji  ,jj) + e12t(ji  ,jj+1) * sshn(ji  ,jj+1) &
+                        &             + e12t(ji+1,jj) * sshn(ji+1,jj) + e12t(ji+1,jj+1) * sshn(ji+1,jj+1) )
+            END DO
+         END DO
+         CALL lbc_lnk( zht(:,:), 'F', 1._wp )
+         CALL lbc_lnk( zwu(:,:), 'F', 1._wp )
+         z_tmax = MAXVAL( fmask(:,:,1) * fmask_i(:,:) * ABS( hf_0(:,:) + zwu(:,:) - zht(:,:) ) )
          IF( lk_mpp ) CALL mpp_max( z_tmax )                                ! max over the global domain
-         IF( lwp    ) WRITE(numout, *) kt,' MAXVAL(abs(sshb))) =', z_tmax
-         !
-         z_tmax = MAXVAL( tmask(:,:,1) *  ABS( sshn(:,:) ) )
-         IF( lk_mpp ) CALL mpp_max( z_tmax )                                ! max over the global domain
-         IF( lwp    ) WRITE(numout, *) kt,' MAXVAL(abs(sshn))) =', z_tmax
-         !
-         z_tmax = MAXVAL( tmask(:,:,1) *  ABS( ssha(:,:) ) )
-         IF( lk_mpp ) CALL mpp_max( z_tmax )                                ! max over the global domain
-         IF( lwp    ) WRITE(numout, *) kt,' MAXVAL(abs(ssha))) =', z_tmax
+         IF( lwp    ) WRITE(numout, *) kt,' MAXVAL(abs(hf_0+sshf_n-SUM(fse3f_n))) =', z_tmax
+         !
       END IF
 
@@ -549,5 +761,5 @@
 
       CALL wrk_dealloc( jpi, jpj, zht, z_scale, zwu, zwv, zhdiv )
-      CALL wrk_dealloc( jpi, jpj, jpk, ze3t                     )
+      CALL wrk_dealloc( jpi, jpj, jpk, ze3t, ztu, ztv           )
 
       IF( nn_timing == 1 )  CALL timing_stop('dom_vvl_sf_nxt')
@@ -583,6 +795,6 @@
       INTEGER, INTENT( in )               :: kt       ! time step
       !! * Local declarations
-      INTEGER                             :: ji,jj,jk       ! dummy loop indices
-      REAL(wp)                            :: zcoef
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zwrk
+      INTEGER                             :: jk       ! dummy loop indices
       !!----------------------------------------------------------------------
 
@@ -607,4 +819,5 @@
          tilde_e3t_n(:,:,:) = tilde_e3t_a(:,:,:)
       ENDIF
+
       fsdept_b(:,:,:) = fsdept_n(:,:,:)
       fsdepw_b(:,:,:) = fsdepw_n(:,:,:)
@@ -620,5 +833,5 @@
       ! - ML - fse3u_b and fse3v_b are allready computed in dynnxt
       ! - JC - hu_b, hv_b, hur_b, hvr_b also
-      CALL dom_vvl_interpol( fse3u_n(:,:,:), fse3f_n (:,:,:), 'F'  )
+      CALL dom_vvl_interpol( fse3t_n(:,:,:), fse3f_n (:,:,:), 'F'  )
       ! Vertical scale factor interpolations
       ! ------------------------------------
@@ -631,23 +844,12 @@
       ! t- and w- points depth
       ! ----------------------
-      ! set the isf depth as it is in the initial step
       fsdept_n(:,:,1) = 0.5_wp * fse3w_n(:,:,1)
       fsdepw_n(:,:,1) = 0.0_wp
       fsde3w_n(:,:,1) = fsdept_n(:,:,1) - sshn(:,:)
-
       DO jk = 2, jpk
-         DO jj = 1,jpj
-            DO ji = 1,jpi
-              !    zcoef = (tmask(ji,jj,jk) - wmask(ji,jj,jk))   ! 0 everywhere tmask = wmask, ie everywhere expect at jk = mikt
-                                                                 ! 1 for jk = mikt
-               zcoef = (tmask(ji,jj,jk) - wmask(ji,jj,jk))
-               fsdepw_n(ji,jj,jk) = fsdepw_n(ji,jj,jk-1) + fse3t_n(ji,jj,jk-1)
-               fsdept_n(ji,jj,jk) =      zcoef  * ( fsdepw_n(ji,jj,jk  ) + 0.5 * fse3w_n(ji,jj,jk))  &
-                   &                + (1-zcoef) * ( fsdept_n(ji,jj,jk-1) +       fse3w_n(ji,jj,jk)) 
-               fsde3w_n(ji,jj,jk) = fsdept_n(ji,jj,jk) - sshn(ji,jj)
-            END DO
-         END DO
+         fsdept_n(:,:,jk) = fsdept_n(:,:,jk-1) + fse3w_n(:,:,jk)
+         fsdepw_n(:,:,jk) = fsdepw_n(:,:,jk-1) + fse3t_n(:,:,jk-1)
+         fsde3w_n(:,:,jk) = fsdept_n(:,:,jk  ) - sshn   (:,:)
       END DO
-
       ! Local depth and Inverse of the local depth of the water column at u- and v- points
       ! ----------------------------------------------------------------------------------
@@ -666,4 +868,8 @@
       END DO
 
+      ! Write additional diagnostics 
+      ! ============================
+      IF( ln_vvl_ztilde .OR. ln_vvl_layer ) CALL dom_vvl_dia( kt) 
+
       ! write restart file
       ! ==================
@@ -674,4 +880,168 @@
    END SUBROUTINE dom_vvl_sf_swp
 
+   SUBROUTINE dom_vvl_dia( kt )
+      !!----------------------------------------------------------------------
+      !!                ***  ROUTINE dom_vvl_dia  ***
+      !!                   
+      !! ** Purpose :  Output some diagnostics in ztilde/zlayer cases
+      !!
+      !!----------------------------------------------------------------------
+      !! * Arguments
+      INTEGER, INTENT( in )               :: kt       ! time step
+      !! * Local declarations
+      INTEGER                             :: ji,jj,jk ! dummy loop indices
+      REAL(wp) :: zufim1, zufi, zvfjm1, zvfj, ztmp1, z2dt
+      REAL(wp), DIMENSION(4)              :: zr1
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zwdw, zout
+      !!----------------------------------------------------------------------
+      IF( nn_timing == 1 )  CALL timing_start('dom_vvl_dia')
+      !
+      CALL wrk_alloc( jpi, jpj, jpk, zwdw, zout )
+      !
+      ! Compute internal interfaces depths:
+      !------------------------------------
+      IF ( iom_use("dh_tilde").OR.iom_use("depw_tilde").OR.iom_use("stiff_tilde")) THEN
+         zwdw(:,:,1) = 0.e0
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 2, jpkm1
+                  zwdw(ji,jj,jk) =  zwdw(ji,jj,jk-1) + & 
+                                 & (tilde_e3t_n(ji,jj,jk-1)+e3t_0(ji,jj,jk-1)) * tmask(ji,jj,jk-1)
+               END DO
+            END DO
+         END DO
+      ENDIF
+      !
+      ! Output interface depth anomaly:
+      ! -------------------------------
+      IF ( iom_use("depw_tilde") ) CALL iom_put( "depw_tilde", (zwdw(:,:,:)-gdepw_0(:,:,:))*tmask(:,:,:) )
+      !
+      ! Output grid stiffness (T-points):
+      ! ---------------------------------
+      IF ( iom_use("stiff_tilde"  ) ) THEN
+         zr1(:)   = 0.e0
+         zout(:,:,jpk) = 0.e0      
+         DO ji = 2, jpim1
+            DO jj = 2, jpjm1
+               DO jk = 1, jpkm1
+                  zr1(1) = umask(ji-1,jj  ,jk) *abs( (zwdw(ji  ,jj  ,jk  )-zwdw(ji-1,jj  ,jk  )  & 
+                       &                             +zwdw(ji  ,jj  ,jk+1)-zwdw(ji-1,jj  ,jk+1)) &
+                       &                            /(zwdw(ji  ,jj  ,jk  )+zwdw(ji-1,jj  ,jk  )  &
+                       &                             -zwdw(ji  ,jj  ,jk+1)-zwdw(ji-1,jj  ,jk+1) + rsmall) )
+                  zr1(2) = umask(ji  ,jj  ,jk) *abs( (zwdw(ji+1,jj  ,jk  )-zwdw(ji  ,jj  ,jk  )  &
+                       &                             +zwdw(ji+1,jj  ,jk+1)-zwdw(ji  ,jj  ,jk+1)) &
+                       &                            /(zwdw(ji+1,jj  ,jk  )+zwdw(ji  ,jj  ,jk  )  &
+                       &                             -zwdw(ji+1,jj  ,jk+1)-zwdw(ji  ,jj  ,jk+1) + rsmall) )
+                  zr1(3) = vmask(ji  ,jj  ,jk) *abs( (zwdw(ji  ,jj+1,jk  )-zwdw(ji  ,jj  ,jk  )  &
+                       &                             +zwdw(ji  ,jj+1,jk+1)-zwdw(ji  ,jj  ,jk+1)) &
+                       &                            /(zwdw(ji  ,jj+1,jk  )+zwdw(ji  ,jj  ,jk  )  &
+                       &                             -zwdw(ji  ,jj+1,jk+1)-zwdw(ji  ,jj  ,jk+1) + rsmall) )
+                  zr1(4) = vmask(ji  ,jj-1,jk) *abs( (zwdw(ji  ,jj  ,jk  )-zwdw(ji  ,jj-1,jk  )  &
+                       &                             +zwdw(ji  ,jj  ,jk+1)-zwdw(ji  ,jj-1,jk+1)) &
+                       &                            /(zwdw(ji  ,jj  ,jk  )+zwdw(ji  ,jj-1,jk  )  &
+                       &                             -zwdw(ji,  jj  ,jk+1)-zwdw(ji  ,jj-1,jk+1) + rsmall) )
+                  zout(ji,jj,jk) = MAXVAL(zr1(1:4))
+               END DO
+            END DO
+         END DO
+
+         CALL lbc_lnk( zout, 'T', 1. )
+         CALL iom_put( "stiff_tilde", zout(:,:,:) ) 
+      END IF
+      ! Output Horizontal Laplacian of interfaces depths (W-points):
+      ! ------------------------------------------------------------
+      IF ( iom_use("dh_tilde")   ) THEN
+         !
+         zout(:,:,1  )=0._wp
+         zout(:,:,jpk)=0._wp
+         DO jk = 2, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  zufim1 = umask(ji-1,jj,jk) * re2u_e1u(ji-1,jj) * ( zwdw(ji-1,jj,jk) - zwdw(ji  ,jj  ,jk) )
+                  zufi   = umask(ji  ,jj,jk) * re2u_e1u(ji  ,jj) * ( zwdw(ji  ,jj,jk) - zwdw(ji+1,jj  ,jk) )
+                  zvfjm1 = vmask(ji,jj-1,jk) * re1v_e2v(ji,jj-1) * ( zwdw(ji,jj-1,jk) - zwdw(ji  ,jj  ,jk) )
+                  zvfj   = vmask(ji,jj  ,jk) * re1v_e2v(ji,jj  ) * ( zwdw(ji,jj  ,jk) - zwdw(ji  ,jj+1,jk) )
+!                  ztmp1  = (zufim1-zufi+zvfjm1-zvfj) * SQRT(r1_e12t(ji,jj))  
+                  ztmp1  = (zufim1-zufi+zvfjm1-zvfj) * r1_e12t(ji,jj) 
+!                  zout(ji,jj,jk) = ABS(ztmp1)*tmask(ji,jj,jk)
+                  zout(ji,jj,jk) = ztmp1
+               END DO
+            END DO            
+         END DO
+         ! Mask open boundaries:
+#if defined key_bdy
+         IF (lk_bdy) THEN
+            DO jk = 1, jpkm1
+               zout(:,:,jk) = zout(:,:,jk) * bdytmask(:,:)
+            END DO
+         ENDIF
+#endif
+         CALL lbc_lnk( zout(:,:,:), 'T', 1. )
+         zwdw(:,:,:) = zout(:,:,:)
+         DO jk = 2, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  zufim1 = umask(ji-1,jj,jk) * re2u_e1u(ji-1,jj) * ( zwdw(ji-1,jj,jk) - zwdw(ji  ,jj  ,jk) )
+                  zufi   = umask(ji  ,jj,jk) * re2u_e1u(ji  ,jj) * ( zwdw(ji  ,jj,jk) - zwdw(ji+1,jj  ,jk) )
+                  zvfjm1 = vmask(ji,jj-1,jk) * re1v_e2v(ji,jj-1) * ( zwdw(ji,jj-1,jk) - zwdw(ji  ,jj  ,jk) )
+                  zvfj   = vmask(ji,jj  ,jk) * re1v_e2v(ji,jj  ) * ( zwdw(ji,jj  ,jk) - zwdw(ji  ,jj+1,jk) )
+!                  ztmp1  = (zufim1-zufi+zvfjm1-zvfj) * SQRT(r1_e12t(ji,jj))  
+                  ztmp1  = (zufim1-zufi+zvfjm1-zvfj) * r1_e12t(ji,jj) 
+                  zout(ji,jj,jk) = ABS(ztmp1)*tmask(ji,jj,jk)
+               END DO
+            END DO            
+         END DO
+         ! Mask open boundaries:
+#if defined key_bdy
+         IF (lk_bdy) THEN
+            DO jk = 1, jpkm1
+               zout(:,:,jk) = zout(:,:,jk) * bdytmask(:,:)
+            END DO
+         ENDIF
+#endif
+         CALL lbc_lnk( zout(:,:,:), 'T', 1. )
+         !
+         CALL iom_put( "dh_tilde", zout(:,:,:) )
+      ENDIF
+      !
+      ! Output vertical Laplacian of interfaces depths (W-points):
+      ! ----------------------------------------------------------
+      IF ( iom_use("dz_tilde"  ) ) THEN
+         zout(:,:,1  ) = 0._wp
+         zout(:,:,jpk) = 0._wp
+         DO jk=2,jpkm1
+            zout(:,:,jk) = 2._wp*ABS(tilde_e3t_n(:,:,jk)+e3t_0(:,:,jk)-tilde_e3t_n(:,:,jk-1)-e3t_0(:,:,jk-1)) & 
+                               &   /(tilde_e3t_n(:,:,jk)+e3t_0(:,:,jk)+tilde_e3t_n(:,:,jk-1)+e3t_0(:,:,jk-1)) &
+                               &   * tmask(:,:,jk)
+         END DO
+         CALL iom_put( "dz_tilde", zout(:,:,:) ) 
+      END IF
+      !
+      !
+      ! Output low pass U-velocity:
+      ! ---------------------------
+      IF ( iom_use("un_lf_tilde"  ).AND.ln_vvl_ztilde ) THEN
+         zout(:,:,jpk) = 0.e0  
+         DO jk=1,jpkm1
+            zout(:,:,jk) = un_lf(:,:,jk)/fse3u_n(:,:,jk)*r1_e2u(:,:)
+         END DO
+         CALL iom_put( "un_lf_tilde", zout(:,:,:) )
+      END IF
+      !
+      ! Output low pass V-velocity:
+      ! ---------------------------
+      IF ( iom_use("vn_lf_tilde"  ).AND.ln_vvl_ztilde ) THEN
+         zout(:,:,jpk) = 0.e0  
+         DO jk=1,jpkm1
+            zout(:,:,jk) = vn_lf(:,:,jk)/fse3v_n(:,:,jk)*r1_e1v(:,:)
+         END DO
+         CALL iom_put( "vn_lf_tilde", zout(:,:,:) )
+      END IF
+      !
+      CALL wrk_dealloc( jpi, jpj, jpk, zwdw, zout )
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('dom_vvl_dia')
+      !
+   END SUBROUTINE dom_vvl_dia
 
    SUBROUTINE dom_vvl_interpol( pe3_in, pe3_out, pout )
@@ -691,6 +1061,11 @@
       !                                                                !   =  'U', 'V', 'W, 'F', 'UW' or 'VW'
       !! * Local declarations
+      INTEGER ::   nmet                                                ! horizontal interpolation method
       INTEGER ::   ji, jj, jk                                          ! dummy loop indices
+      INTEGER ::   jkbot                                               ! bottom level
       LOGICAL ::   l_is_orca                                           ! local logical
+      REAL(wp) :: zmin, zdo, zup, ztap
+      REAL(wp), POINTER, DIMENSION(:,:)   :: zs                        ! Surface interface depth anomaly
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zw                        ! Interface depth anomaly
       !!----------------------------------------------------------------------
       IF( nn_timing == 1 )  CALL timing_start('dom_vvl_interpol')
@@ -698,19 +1073,118 @@
       l_is_orca = .FALSE.
       IF( cp_cfg == "orca" .AND. jp_cfg == 2 ) l_is_orca = .TRUE.      ! ORCA R2 configuration - will need to correct some locations
+
+ 
+      nmet=1 ! Original method (Surely wrong)
+!      nmet=1 ! Interface interpolation
+!      nmet=2 ! Internal interfaces interpolation only, spread barotropic increment
+!      nmet=1
+      ztap = 0.1_wp ! Minimum fraction of T-point thickness at cell interfaces
+
+      IF ( (nmet==1).OR.(nmet==2) ) THEN
+         SELECT CASE ( pout )
+            !
+         CASE( 'U', 'V', 'F' )
+            ! Compute interface depth anomaly at T-points
+            CALL wrk_alloc( jpi, jpj, jpk, zw )
+            CALL wrk_alloc( jpi, jpj, zs )
+            !
+            zw(:,:,:) =  0._wp    
+            !
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  jkbot = mbkt(ji,jj)
+                  DO jk=jkbot,1,-1
+                     zw(ji,jj,jk) = zw(ji,jj,jk+1) - pe3_in(ji,jj,jk) + e3t_0(ji,jj,jk)
+                  END DO
+               END DO
+            END DO 
+            !
+            !
+            IF (nmet==2) THEN        ! Consider "internal" interfaces only
+               zs(:,:) = - zw(:,:,1) ! Save surface anomaly (ssh)
+               !
+               zw(:,:,:) = 0._wp
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     jkbot = mbkt(ji,jj)
+                     DO jk=jkbot,1,-1
+                        zw(ji,jj,jk) = zw(ji,jj,jk+1) - ( pe3_in(ji,jj,jk)                     &
+                                     & * ht_0(ji,jj) / (ht_0(ji,jj) + zs(ji,jj) + 1._wp - tmask(ji,jj,1))  &
+                                     & - e3t_0(ji,jj,jk)) * tmask(ji,jj,jk)
+                     END DO
+                  END DO
+               END DO 
+            ENDIF 
+            !
+         END SELECT
+      END IF
+
+      pe3_out(:,:,:) = 0._wp
 
       SELECT CASE ( pout )
          !               ! ------------------------------------- !
       CASE( 'U' )        ! interpolation from T-point to U-point !
-         !               ! ------------------------------------- !
+         !               ! ------------------------------------- !     
          ! horizontal surface weighted interpolation
-         DO jk = 1, jpk
+         IF (nmet==0) THEN
+            DO jk = 1, jpk
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1   ! vector opt.
+                     pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk) * r1_e12u(ji,jj)                                   &
+                        &                       * (   e12t(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3t_0(ji  ,jj,jk) )     &
+                        &                           + e12t(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3t_0(ji+1,jj,jk) ) )
+                  END DO
+               END DO
+            END DO
+         ENDIF
+         !
+         IF ( (nmet==1).OR.(nmet==2) ) THEN
             DO jj = 1, jpjm1
                DO ji = 1, fs_jpim1   ! vector opt.
-                  pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk) * r1_e12u(ji,jj)                                   &
-                     &                       * (   e12t(ji  ,jj) * ( pe3_in(ji  ,jj,jk) - e3t_0(ji  ,jj,jk) )     &
-                     &                           + e12t(ji+1,jj) * ( pe3_in(ji+1,jj,jk) - e3t_0(ji+1,jj,jk) ) )
-               END DO
-            END DO
-         END DO
+                  ! Correction at last level:
+                  jkbot = mbku(ji,jj)
+                  pe3_out(ji,jj,jkbot) = -0.5_wp * umask(ji,jj,jkbot) * r1_e12u(ji,jj) &
+                        &                    * (   e12t(ji  ,jj) * zw(ji  ,jj,jkbot)   &
+                        &                        + e12t(ji+1,jj) * zw(ji+1,jj,jkbot)   )
+                  !
+                  ! If there is a step, taper bottom interface:
+                  IF (hu_0(ji,jj) < 0.5_wp * ( ht_0(ji,jj) + ht_0(ji+1,jj) ) ) THEN
+                     IF ( ht_0(ji+1,jj) < ht_0(ji,jj) ) THEN
+!                        zmin = ztap * pe3_in(ji+1,jj,jkbot)
+                        zmin = ztap * (-zw(ji+1,jj,jkbot)+e3t_0(ji+1,jj,jkbot))
+                     ELSE
+!                        zmin = ztap * pe3_in(ji  ,jj,jkbot)
+                        zmin = ztap * (-zw(ji,jj,jkbot)+e3t_0(ji,jj,jkbot))
+                     ENDIF
+                     zmin = -e3u_0(ji,jj,jkbot) + zmin
+                     pe3_out(ji,jj,jkbot) = MAX(pe3_out(ji,jj,jkbot), zmin)
+                  ENDIF
+                  !
+                  zdo =  -pe3_out(ji,jj,jkbot)
+                  DO jk=jkbot-1,1,-1
+                     zup = 0.5_wp * umask(ji,jj,jk) * r1_e12u(ji  ,jj) &
+                              &                     *(   e12t(ji  ,jj) * zw(ji  ,jj,jk)  &
+                              &                         +e12t(ji+1,jj) * zw(ji+1,jj,jk)  )
+                     pe3_out(ji,jj,jk) = zdo - zup  
+                     zdo =  zdo - pe3_out(ji,jj,jk)
+                  END DO
+               END DO
+            END DO
+         END IF
+         ! 
+         IF (nmet==2) THEN           ! Spread sea level anomaly
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  DO jk=1,jpk
+                     pe3_out(ji,jj,jk) =       pe3_out(ji,jj,jk)                                 &
+                           &               + ( pe3_out(ji,jj,jk) + e3u_0(ji,jj,jk) )             & 
+                           &               / ( hu_0(ji,jj) + 1._wp - umask_i(ji,jj) )            &
+                           &               * 0.5_wp * umask(ji,jj,jk) * r1_e12u(ji,jj)           &
+                           &               * ( e12t(ji,jj)*zs(ji,jj) + e12t(ji+1,jj)*zs(ji+1,jj) )       
+                  END DO
+               END DO
+            END DO
+            !
+         ENDIF
          !
          IF( l_is_orca ) CALL dom_vvl_orca_fix( pe3_in, pe3_out, pout )
